package com.nationrel.modules.rp.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.nationrel.modules.rp.entity.PredictionTable;
import com.nationrel.modules.rp.mapper.PredictionTableMapper;
import com.nationrel.modules.rp.service.IPredictionTableService;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.vo.LoginUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;

/**
 * @Description: prediction_table
 * @Author: nationrel
 * @Date:   2024-09-02
 * @Version: V1.0
 */
@Service
public class PredictionTableServiceImpl extends ServiceImpl<PredictionTableMapper, PredictionTable> implements IPredictionTableService {

    @Autowired
    private PredictionTableMapper predictionTableMapper;

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveOrUpdateTable(PredictionTable predictionTable) {
        LoginUser sysUser = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        PredictionTable table = predictionTableMapper.selectOne(new LambdaQueryWrapper<PredictionTable>()
                .eq(PredictionTable::getPredictionId, predictionTable.getPredictionId())
                .eq(PredictionTable::getStruId, predictionTable.getStruId())
                .eq(PredictionTable::getColumnsId, predictionTable.getColumnsId()));
        if (ObjectUtils.isNotEmpty(table)) {
            table.setValue(predictionTable.getValue());
            table.setUpdateBy(sysUser.getUsername());
            table.setUpdateTime(new Date());
            table.setVersionNo(table.getVersionNo()+1);
            predictionTableMapper.updateById(table);
        } else {
            predictionTable.setCreateBy(sysUser.getUsername());
            predictionTable.setCreateTime(new Date());
            predictionTableMapper.insert(predictionTable);
        }
    }
}
